/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix;

import engcalculator.data.Interval;
import engcalculator.data.Literal;
import engcalculator.function.CalculusException;
import engcalculator.variable.Variable;

/**
 *
 * @author simone
 */
public class Delete extends SingleInputSingleOutputPrefixFunction {

    public Delete() {
        super ("delete", false, true, "Delete a function or a variable. Ex.: delete ('x') deletes the variable or function x.", null, null);
    }

    @Override
    public Interval _computeIntervals(Interval input) throws Exception {

        String fname = input.getName();
        if (fname == null) throw new CalculusException ("It is expected a literal naming a function or variable to be deleted.");

        boolean found = Variable.delVariable(fname);
        StringBuffer result = new StringBuffer();

        if (found) return new Literal(result.append("Variable ").append(fname).append(" deleted").toString());

        found = PrefixFunction.delFunction(fname);

        if (found) return new Literal(result.append("Function ").append(fname).append(" deleted").toString());

        throw new CalculusException ("It is not possible to find anything called "+fname+" or the it is a constant");
    }
}
