/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.decibel;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;
import engcalculator.function.prefix.logarithm.Log;
import engcalculator.function.infix.arithmetic.Mul;

/**
 *
 * @author simone
 */
public abstract class LinToDB extends PrefixFunction {
    private IntervalList coefficient;
    private final static Log LOG = new Log();
    private final static Mul MUL = new Mul();

    public LinToDB(String name, int coefficient, String[] examples, String[] results) {
        super (name, (byte) 1, true, true, name+" converts a linear interval a to a logarithmic one returning: "+coefficient+"*log a.", examples, results);
        this.coefficient = new IntervalList(new Interval(coefficient));
    }


    @Override
    public final IntervalList _compute(IntervalList input) throws Exception {
        return MUL._compute(coefficient, LOG._compute(input));
    }
}
