/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.interval;

import engcalculator.data.Interval;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;

/**
 *
 * @author simone
 */
public class Invert extends SingleInputSingleOutputPrefixFunction {

    private final static String[] EXAMPLE = {"2, 4"};
    private final static String[] RESULT = {"0.5, 0.25"};
    
    public Invert() {
        super ("invert", true, true, "invert inverts a list of intervals. It is extended to Directed intervals.", EXAMPLE, RESULT);
    }

    public Interval _computeIntervals(Interval input) throws Exception {
        if (input.containsZero()) {
            throw new CalculusException ("Not possible to divide by an interval conaining 0");
        }
        return new Interval(1/input.getRight(), 1/input.getLeft());
    }


}
