/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.expression.token;

/**
 *
 * @author simone
 */
public class TerminalTkn extends Token {
    public static final String TERMINALS = ";()[]";

    public TerminalTkn() {}
    
    private TerminalTkn(String terminal) {
        super (terminal);
    }

    @Override
    public String getTerminal() {
        return getSymbol();
    }

    @Override
    public Token generateToken(String symbol) {
        if  (TERMINALS.indexOf(symbol) == -1 || symbol.length() != 1) return null;
        return new TerminalTkn(symbol);
    }

    @Override
    public boolean mayBeCompatible( String symbol) {
        return (TERMINALS.indexOf(symbol) != -1 && symbol.length() == 1);
    }

}
