/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.compare;

import engcalculator.data.Interval;

/**
 *
 * @author simone
 */
public class GreaterEqual extends ComparisonInfixFunction {
    private final static String[] EXAMPLE_LEFT = {"6_7","6_7", "1_2", "3_4"};
    private final static String[] EXAMPLE_RIGHT = {"4_5","5_6", "2_4", "-3_-2"};
    private final static String[] RESULT = {"1","1","0","1"};

    public GreaterEqual() {
        super(">=", ">= checks if an interval is greater or equal than another returning 0 for false, 1 for true. Greater or equal means every element of the firs interval is >= than every element of the second. Extended to directed intervals.", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public boolean compare(Interval a, Interval b) throws Exception {
        if (a.getName() != null && b.getName() != null) return (a.getName().compareTo(b.getName()) >= 0);
        return a.getRight() >= b.getRight() && a.getLeft() >= b.getLeft();
    }
}
