/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.interval;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class Distance extends PrefixFunction {
    private final static String[] EXAMPLE = {"-10_10, 3_4", "10_-5, 3_4", "10_10, 3_4"};
    private final static String[] RESULT = {"13", "9", "7"};

    public Distance() {
        super("distance", (byte) 2, true, true, "compute the distance between two intervals which is the maximum between the absolute difference for their extreme points.", EXAMPLE , RESULT);
    }
    
    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        Interval i1 = input.getFirst(), i2 = input.get(1);
        return new IntervalList(new Interval(Math.max(Math.abs(i1.getLeft()-i2.getLeft()), Math.abs(i1.getRight()-i2.getRight()))));
    }
}
