/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.interval;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class Extremes extends PrefixFunction {

    private final static String[] EXAMPLE = {"1%4"};
    private final static String[] RESULT = {"(0.960, 1.04)"};


    public Extremes() {
        super ("extremes", (byte) 1, true, true, "returns a list with the first and second end point of an interval.", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        Interval a = input.getFirst();
        IntervalList result = new IntervalList();
        result.append (new Interval(a.getLeft()));
        result.append (new Interval(a.getRight()));
        return result;
    }

}
