/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.statistic;

import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;
import engcalculator.function.infix.arithmetic.Sub;
import engcalculator.function.prefix.square.Square;

/**
 *
 * @author simone
 */
public class Variance extends PrefixFunction {
    private final static Average AVERAGE = new Average ();
    private final static Sub SUB = new Sub();
    private final static Square SQR = new Square();

    private final static String[] EXAMPLE = {"1,1"};
    private final static String[] RESULT = {"0"};

    public Variance() {
        super("variance", (byte) -1, false, true, "variance returns the average of the difference among a list of value and its average value squared.", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        return AVERAGE._compute(SQR.compute(SUB.compute(AVERAGE.compute(input), input)));
    }
}
